/*
 File: mpost_outputsym.cpp
 Date and Time: Fri Jan 30 18:55:16 2015 
*/
#include "mpost_output.h"
using namespace NS_yacco2_T_enum;// enumerate
using namespace NS_yacco2_err_symbols;// error symbols
using namespace NS_yacco2_k_symbols;// lrk 
using namespace NS_yacco2_terminals;// terminals
using namespace NS_yacco2_characters;// rc 
using namespace yacco2;// yacco2 library
using namespace NS_mpost_output;// grammar's ns
// first set terminals
// monolithic grammar --- no thread
void 
Cmpost_output::reduce_rhs_of_rule
    (yacco2::UINT Sub_rule_no,yacco2::Rule_s_reuse_entry** Recycled_rule){
   int reducing_rule = rhs_to_rules_mapping_[Sub_rule_no];
   Per_rule_s_reuse_table* rule_reuse_tbl_ptr = 
        fsm_rules_reuse_table.per_rule_s_table_[reducing_rule];
   Rule_s_reuse_entry* re(0);
   find_a_recycled_rule(rule_reuse_tbl_ptr,&re);
   (*Recycled_rule) = re;
   fnd_re: switch (Sub_rule_no){
    case rhs1_Rmpost_output_:{
       Rmpost_output* sym;
     if(re->rule_ == 0){
       sym = new Rmpost_output(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rmpost_output*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 20;
    

     sym->sr1();
     return;}
    case rhs1_Rgrammar_phrase_:{
       Rgrammar_phrase* sym;
     if(re->rule_ == 0){
       sym = new Rgrammar_phrase(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rgrammar_phrase*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs1_Rks_epi_:{
       Rks_epi* sym;
     if(re->rule_ == 0){
       sym = new Rks_epi(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rks_epi*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs2_Rks_epi_:{
       Rks_epi* sym;
     if(re->rule_ == 0){
       sym = new Rks_epi(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rks_epi*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 0;
    

     return;}
    case rhs1_Rks_:{
       Rks* sym;
     if(re->rule_ == 0){
       sym = new Rks(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rks*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs2_Rks_:{
       Rks* sym;
     if(re->rule_ == 0){
       sym = new Rks(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rks*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs1_Rk_:{
       Rk* sym;
     if(re->rule_ == 0){
       sym = new Rk(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rk*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr1();
     return;}
    case rhs1_Rfsm_phrase_:{
       Rfsm_phrase* sym;
     if(re->rule_ == 0){
       sym = new Rfsm_phrase(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rfsm_phrase*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr1();
     return;}
    case rhs1_Rparallel_phrase_:{
       Rparallel_phrase* sym;
     if(re->rule_ == 0){
       sym = new Rparallel_phrase(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rparallel_phrase*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs2_Rparallel_phrase_:{
       Rparallel_phrase* sym;
     if(re->rule_ == 0){
       sym = new Rparallel_phrase(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rparallel_phrase*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs1_RT_enum_phrase_:{
       RT_enum_phrase* sym;
     if(re->rule_ == 0){
       sym = new RT_enum_phrase(parser__);
       re->rule_ = sym;
     }else{
       sym = (RT_enum_phrase*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs1_Rerr_phrase_:{
       Rerr_phrase* sym;
     if(re->rule_ == 0){
       sym = new Rerr_phrase(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rerr_phrase*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr1();
     return;}
    case rhs1_Rrc_phrase_:{
       Rrc_phrase* sym;
     if(re->rule_ == 0){
       sym = new Rrc_phrase(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rrc_phrase*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs1_Rlr1_k_phrase_:{
       Rlr1_k_phrase* sym;
     if(re->rule_ == 0){
       sym = new Rlr1_k_phrase(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rlr1_k_phrase*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr1();
     return;}
    case rhs1_Rterms_phrase_:{
       Rterms_phrase* sym;
     if(re->rule_ == 0){
       sym = new Rterms_phrase(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rterms_phrase*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr1();
     return;}
    case rhs1_Rrule_phrase_:{
       Rrule_phrase* sym;
     if(re->rule_ == 0){
       sym = new Rrule_phrase(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rrule_phrase*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr1();
     return;}
    case rhs1_Rrules_:{
       Rrules* sym;
     if(re->rule_ == 0){
       sym = new Rrules(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rrules*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs2_Rrules_:{
       Rrules* sym;
     if(re->rule_ == 0){
       sym = new Rrules(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rrules*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 3;
    

     return;}
    case rhs1_Rrule_:{
       Rrule* sym;
     if(re->rule_ == 0){
       sym = new Rrule(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rrule*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs1_Rrule_def_:{
       Rrule_def* sym;
     if(re->rule_ == 0){
       sym = new Rrule_def(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rrule_def*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr1();
     return;}
    case rhs1_Rsubrules_:{
       Rsubrules* sym;
     if(re->rule_ == 0){
       sym = new Rsubrules(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rsubrules*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs2_Rsubrules_:{
       Rsubrules* sym;
     if(re->rule_ == 0){
       sym = new Rsubrules(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rsubrules*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs1_Rsubrule_:{
       Rsubrule* sym;
     if(re->rule_ == 0){
       sym = new Rsubrule(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rsubrule*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs1_Rsubrule_def_:{
       Rsubrule_def* sym;
     if(re->rule_ == 0){
       sym = new Rsubrule_def(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rsubrule_def*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr1();
     return;}
    case rhs1_Relements_:{
       Relements* sym;
     if(re->rule_ == 0){
       sym = new Relements(parser__);
       re->rule_ = sym;
     }else{
       sym = (Relements*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs2_Relements_:{
       Relements* sym;
     if(re->rule_ == 0){
       sym = new Relements(parser__);
       re->rule_ = sym;
     }else{
       sym = (Relements*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs1_Relement_:{
       Relement* sym;
     if(re->rule_ == 0){
       sym = new Relement(parser__);
       re->rule_ = sym;
     }else{
       sym = (Relement*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     sym->sr1();
     return;}
    case rhs2_Relement_:{
       Relement* sym;
     if(re->rule_ == 0){
       sym = new Relement(parser__);
       re->rule_ = sym;
     }else{
       sym = (Relement*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr2();
     return;}
    case rhs3_Relement_:{
       Relement* sym;
     if(re->rule_ == 0){
       sym = new Relement(parser__);
       re->rule_ = sym;
     }else{
       sym = (Relement*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     sym->sr3();
     return;}
    case rhs4_Relement_:{
       Relement* sym;
     if(re->rule_ == 0){
       sym = new Relement(parser__);
       re->rule_ = sym;
     }else{
       sym = (Relement*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 3;
    

     sym->sr4();
     return;}
    case rhs5_Relement_:{
       Relement* sym;
     if(re->rule_ == 0){
       sym = new Relement(parser__);
       re->rule_ = sym;
     }else{
       sym = (Relement*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 3;
    

     sym->sr5();
     return;}
    case rhs6_Relement_:{
       Relement* sym;
     if(re->rule_ == 0){
       sym = new Relement(parser__);
       re->rule_ = sym;
     }else{
       sym = (Relement*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 3;
    

     sym->sr6();
     return;}
    default: return;
   }
}
